package dataReductionRules;

/**
 * If an instance is unsolvable the {@link DataReductionRuleProvider} throws this exception.
 * 
 * @author Sepp Hartung
 * @version 1.0
 * 
 */
public class UnsolvableException extends Exception
{
	private static final long serialVersionUID = -3735504096819065259L;

	public UnsolvableException()
	{
		super();
	}

	public UnsolvableException(final String string)
	{
		super(string);
	}

}
