package dataReductionRules.rule3HelpClasses.deprecated;

import java.util.Iterator;
import java.util.TreeSet;
import java.util.Vector;

import org.jgrapht.graph.DefaultEdge;

public class NodeKey implements Comparable
{

	public Vector<Integer> characters;

	Node v;

	public NodeKey(final Node v)
	{
		this.v = v;
		this.characters = new Vector<Integer>();
	}

	public NodeKey(final Node v, final Vector<Integer> c)
	{
		this.v = v;
		this.characters = c;
	}

	public int compareTo(final NodeKey key)
	{
		// System.out.println("yyy0");
		if (this.v.equals(key.v))
			return 0;
		// System.out.println("yyy1");
		if (this.characters.size() < key.characters.size())
			return -1;
		// System.out.println("yyy2");
		if (this.characters.size() > key.characters.size())
			return 1;
		// System.out.println("yyy3");
		int i;
		for (i = 0; i < key.characters.size(); ++i)
		{
			if (!this.characters.get(i).equals(key.characters.get(i)))
				return this.characters.get(i).intValue() - key.characters.get(i).intValue();
		}

		// System.out.println("yyy4");
		final Iterator<DefaultEdge> Adj1 = this.v.G.edgesOf(this.v).iterator();
		final TreeSet<Node> N1 = new TreeSet<Node>();
		// System.out.println("yyy4.1");
		while (Adj1.hasNext())
		{
			final DefaultEdge e = Adj1.next();
			N1.add(this.v.G.getEdgeSource(e));
			N1.add(this.v.G.getEdgeTarget(e));
		}
		// System.out.println("yyy5");

		final TreeSet<Node> N2 = new TreeSet<Node>();
		final Iterator<DefaultEdge> Adj2 = key.v.G.edgesOf(key.v).iterator();
		while (Adj2.hasNext())
		{
			final DefaultEdge e = Adj2.next();
			N2.add(key.v.G.getEdgeSource(e));
			N2.add(key.v.G.getEdgeTarget(e));
		}

		// System.out.println("yyy6");
		final Iterator<Node> I1 = N1.iterator();
		final Iterator<Node> I2 = N2.iterator();

		while (I1.hasNext() && I2.hasNext())
		{
			final Node v1 = I1.next();
			final Node v2 = I2.next();
			if (!v1.equals(v2))
				return v1.i - v2.i;
		}

		// System.out.println("EQUAL KEYS");
		return 0;
	}

	@Override
	public int compareTo(final Object oo)
	{
		try
		{
			final NodeKey key = (NodeKey) oo;
			return this.compareTo(key);
		} catch (final java.lang.ClassCastException e)
		{
			System.err.println("ClassCast Exception: " + e.getMessage());
		}

		return -1;
	}
}
