package benchmark.realWorldData;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Iterator;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;

public class sortCM
{

	public static void main(final String[] args) throws Exception
	{

		class containsSuffix implements FilenameFilter
		{
			public String sfx;

			public containsSuffix(final String s)
			{
				this.sfx = s;
			}

			@Override
			public boolean accept(final File dir, final String name)
			{
				if (name.endsWith(this.sfx))
					return true;
				return false;
			}
		}
		;

		final TreeMap<String, String> names = new TreeMap<String, String>();
		final String filePath = args[0];
		final File folder = new File(filePath);
		// final LogFileWriter logWriter = new LogFileWriter();
		for (final String fileName : folder.list(new containsSuffix(".cm")))
		{
			final StringTokenizer st = new StringTokenizer(fileName, "_");
			String s;
			while (st.hasMoreTokens())
			{
				s = st.nextToken();
				if (s.equals("size"))
				{
					String size = st.nextToken();
					if (size.length() <= 5)
					{
						String pre = "";
						for (int i = 0; i < (5 - size.length()); ++i)
						{
							pre = pre + "0";
						}

						size = pre + size;
					}

					names.put(fileName, "SIZE_" + size + "_-_" + fileName);
					break;
				}

			}

		}

		final Iterator<Map.Entry<String, String>> I = names.entrySet().iterator();
		while (I.hasNext())
		{
			final Map.Entry<String, String> e = I.next();
			final String command = "mv " + filePath + "/" + e.getKey() + " " + filePath + "/" + e.getValue();
			System.out.println(command);
			Runtime.getRuntime().exec(command);
		}

	}
}
