package solver.approximationHClustPivot.hcUtils;

public class StrPair implements Comparable
{
	public String s1;

	public String s2;

	public StrPair(final String s, final String t)
	{
		if (s.compareTo(t) < 0)
		{
			this.s1 = s;
			this.s2 = t;
		} else
		{
			this.s2 = s;
			this.s1 = t;
		}
	}

	@Override
	public int compareTo(final Object oo)
	{
		try
		{
			return this.compareTo((StrPair) oo);
		} catch (final Exception e)
		{
			System.err.println("Exception: " + e.getMessage());
		}
		return -1;
	}

	public int compareTo(final StrPair v)
	{
		if (this.s1.compareTo(v.s1) < 0)
			return -1;
		if (this.s1.compareTo(v.s1) > 0)
			return 1;

		if (this.s2.compareTo(v.s2) > 0)
			return 1;
		if (this.s2.compareTo(v.s2) < 0)
			return -1;

		return 0;
	}
}
