package solver.hierarchicalClustering;

import java.util.Collection;

import distanceFunction.ReadOnlyViewOnSymmetricDiscreteDistanceFunction;
import distanceFunction.SymmetricDiscreteDistanceFunction;

public interface SolverInterface
{
	public ReadOnlyViewOnSymmetricDiscreteDistanceFunction getConflictEdgeStatistic();

	public Collection<int[]> getConflicts();

	public SymmetricDiscreteDistanceFunction getDistanceFunction();

	public ReadOnlyViewOnSymmetricDiscreteDistanceFunction getNonConflictEdgeStatistic();

	public int getParameterValue();

}
